#ifndef __CROSS_UTILS_H__
#define __CROSS_UTILS_H__

#define SOCK_PATH       "/tmp/huilian_socket"
#define MAX_CLIENT      2
#include <nvbuf_utils.h>



struct nvbuf_param {
    NvBufferParams params;
    NvBufferParamsEx paramsEx;
};

class CrossUtils
{
public:
    CrossUtils();
    ~CrossUtils();
	int ServerCreate();
    int ClientCreate();
	int send_fd(int fd,nvbuf_param *par);
	int recv_fd(int sockfd,nvbuf_param *par);
    int Get_Flag(int index);
	static void* ServerThreadFun(void* pParam);
	
	int ancil_send_fd(int fd);
	int ancil_send_fds_with_buffer(int sock, const int *fds, unsigned n_fds, void *buffer);
	int ancil_recv_fd(int sock,int *fd);
	int ancil_recv_fds_with_buffer(int sock, int *fds, unsigned n_fds, void *buffer);
private:
    uint32_t get_time_diff_ms(const struct timeval *start, const struct timeval *end);
	int m_nClientfd[MAX_CLIENT];
	int m_nFlag[MAX_CLIENT];
	int m_nSocketfd;
	int m_nCount;
};

#endif
